﻿var SendNowNicoNico = {
  niconico: false,
  set: function() {
    window.removeEventListener('load', SendNowNicoNico.set, false);
    window.addEventListener('unload', SendNowNicoNico.unset, false);
    window.addEventListener('DOMContentLoaded', SendNowNicoNico.onContentLoad, false);
  },
  onContentLoad: function( targetevent ) {
    var loc = targetevent.originalTarget.location;
    var obj = Components.classes['@osa-p.net/SendNowNicoNico;1'].createInstance(Components.interfaces.SendNowNicoNico);
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.sendnowniconico.");
    var search_flag = prefs.getBoolPref("search_flag");
    
    if ((loc.hostname == 'www.nicovideo.jp') && ( loc.pathname.match("^/watch/") )) {
      var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

      var send_flag = prefs.getBoolPref("send_flag");
      var WindowTitle = '';
      var strTitle = '';
      if (send_flag) {
        var header = prefs.getComplexValue("title_header", Components.interfaces.nsISupportsString).data;
        var footer = prefs.getComplexValue("title_footer", Components.interfaces.nsISupportsString).data;
        
        WindowTitle = window.document.title;
        //WindowTitle.match("^ニコニコ動画\\(RC\\).(.+) \\- Mozilla Firefox");
        var pattern;
        pattern = ("^" + header + "(.+)");
        WindowTitle.match( pattern );
        strTitle = RegExp.$1;
        pattern = ("(.+)" + footer + "$");
        strTitle.match( pattern );
        strTitle = RegExp.$1;
	      consoleService.logStringMessage("Send Now Niconico:WindowTitle/SetTitle\n" + WindowTitle + "\n" + strTitle);
      }

      if (strTitle != '') {
        var send_id = prefs.getBoolPref("send_id");
        if (send_id) {
          loc.pathname.match("^/watch/(.+)");
          strTitle = '(' + RegExp.$1 + ')' + strTitle;
        }
        
        obj.SetMusic( strTitle, search_flag );
        this.niconico = true;
      }
      else {
        if (this.niconico) {
          obj.UnsetMusic( search_flag );
          this.niconico = false;
        }
      }
    }
    else {
      if (this.niconico) {
        obj.UnsetMusic( search_flag );
        this.niconico = false;
      }
    }
  },
  unset: function() {
    window.removeEventListener("unload", SendNowNicoNico.unset, false);
    if (this.niconico) {
      var obj = Components.classes["@osa-p.net/SendNowNicoNico;1"].createInstance(Components.interfaces.SendNowNicoNico);
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      prefs = prefs.getBranch("extensions.sendnowniconico.");
      var search_flag = prefs.getBoolPref("search_flag");
      obj.UnsetMusic( search_flag );
      this.niconico = false;
    }
  }
};
window.addEventListener('load', SendNowNicoNico.set, false);
